#include "stdafx.h"
#include "NeMessenger.h"
#include "SelectTelnoDlg.h"

#define ST_DLG_BTN_WIDTH		80
#define ST_DLG_BTN_HEIGHT		28
#define ST_DLG_BTN_GAP_X		4

#define BTN_HEIGHT				36

#define COLOR_LIST_BORDER		(RGB(220,220,220))		// #dcdcdc
#define WM_ASYNC_DESTROYWINDOW  (WM_USER + 16)

IMPLEMENT_DYNAMIC(CSelectTelnoDlg, CSkinDialog)

CSelectTelnoDlg::CSelectTelnoDlg(CWnd* pParent /*=NULL*/)
	: CSkinDialog(CSelectTelnoDlg::IDD, pParent)
{
	m_strExtensionTelno = _T("");
	m_strIncoTelno = _T("");
	m_strCellPhone = _T("");

	m_pOKCancelButtons = NULL;
	m_strForwardingTelNo = _T("");
}

CSelectTelnoDlg::~CSelectTelnoDlg()
{
	m_penBorder.DeleteObject();
}

void CSelectTelnoDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_RADIO_TEL_1, m_radioExtensionTelNo);
	DDX_Control(pDX, IDC_RADIO_TEL_2, m_radioCellPhone);
	DDX_Control(pDX, IDC_RADIO_TEL_3, m_radioInputTelNo);
	DDX_Control(pDX, IDC_EDIT_TELNO, m_editTelno);
}

BEGIN_MESSAGE_MAP(CSelectTelnoDlg, CSkinDialog)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDOK, &CSelectTelnoDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_RADIO_TEL_1, &CSelectTelnoDlg::OnBnClickedRadioTel1)
	ON_BN_CLICKED(IDC_RADIO_TEL_2, &CSelectTelnoDlg::OnBnClickedRadioTel2)
	ON_BN_CLICKED(IDC_RADIO_TEL_3, &CSelectTelnoDlg::OnBnClickedRadioTel3)
END_MESSAGE_MAP()


BOOL CSelectTelnoDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	ModifyStyle(0, WS_THICKFRAME);
	ModifyStyle(0, WS_CLIPCHILDREN);

	__ResourceLoad(TRUE);

	//  â 
	MoveWindow(0, 0, 290, 210);
	CenterWindow();
	//SetSkin();

	ReSizeCtrl();
	RedrawWindow();

	m_radioExtensionTelNo.SetCheck(BST_CHECKED);

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CSelectTelnoDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// ȭ 

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	//memDC.MoveTo(0, 0);
	//memDC.LineTo(rcClient.right, 0);

	// ϴ μ
	//memDC.MoveTo(0, rcClient.bottom - 49);
	//memDC.LineTo(rcClient.right, rcClient.bottom - 49);

	// Font 
	CFont* pOldFont;
	pOldFont = memDC.SelectObject(&g_ftDefault9PT);

	CRect rcText(0, 0, 0, 0);
	rcText.SetRect(20, 30, rcClient.Width() - 20, 60);

	memDC.SelectObject(&g_ftDefault9PT);

	memDC.SetBkMode(TRANSPARENT);
	memDC.SetTextColor(RGB(102, 102, 102));

	rcText.left = 110;
	rcText.right = rcClient.right - 20;
	rcText.top = 29;
	rcText.bottom = rcText.top + 29;
	memDC.DrawText(m_strExtensionTelno, rcText, DT_LEFT | DT_NOPREFIX);

	rcText.OffsetRect(0, 30);
	memDC.DrawText(m_strCellPhone, rcText, DT_LEFT | DT_NOPREFIX);

	// memDC  ׸  ѹ DC ׷  .
	dc.BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);	

	memDC.SelectObject(pOldPen);
	memDC.SelectObject(pOldFont);
}

void CSelectTelnoDlg::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base2.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CSelectTelnoDlg::__ResourceLoad(BOOL bInit)
{
	if (bInit == TRUE)
	{
		// â  
		m_penBorder.CreatePen(PS_SOLID, 1, COLOR_LIST_BORDER);

		m_radioExtensionTelNo.SetFont(&g_ftDefault9PTB);
		m_radioExtensionTelNo.SetTextColor(RGB(94, 95, 109));
		m_radioExtensionTelNo.SetBkColor(RGB(255, 255, 255));
		m_radioExtensionTelNo.LoadBitmaps(_T(""),
			GetAppImgFile(_T("13_Radio_Button_Unchecked.bmp")), 
			GetAppImgFile(_T("13_Radio_Button_Checked.bmp")));

		m_radioCellPhone.SetFont(&g_ftDefault9PTB);
		m_radioCellPhone.SetTextColor(RGB(94, 95, 109));
		m_radioCellPhone.SetBkColor(RGB(255, 255, 255));
		m_radioCellPhone.LoadBitmaps(_T(""),
			GetAppImgFile(_T("13_Radio_Button_Unchecked.bmp")), 
			GetAppImgFile(_T("13_Radio_Button_Checked.bmp")));


		m_radioInputTelNo.SetFont(&g_ftDefault9PTB);
		m_radioInputTelNo.SetTextColor(RGB(94, 95, 109));
		m_radioInputTelNo.SetBkColor(RGB(255, 255, 255));
		m_radioInputTelNo.LoadBitmaps(_T(""),
			GetAppImgFile(_T("13_Radio_Button_Unchecked.bmp")), 
			GetAppImgFile(_T("13_Radio_Button_Checked.bmp")));

		m_radioExtensionTelNo.SetWindowText(LoadStringFromResource(IDS_STRING270));
		m_radioCellPhone.SetWindowText(LoadStringFromResource(IDS_STRING272));
		m_radioInputTelNo.SetWindowText(LoadStringFromResource(IDS_STRING613));

		m_editTelno.SetFont(&g_ftDefault9PT);
		m_editTelno.EnableWindow(FALSE);


		SetWindowText(LoadStringFromResource(IDS_TOPMENU_FORWARDING));
		SetShowTitle(FALSE);
		SetDialogShowWindowText(true);
		SetDialogWindowText(LoadStringFromResource(IDS_TOPMENU_FORWARDING));
		SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
		SetWindowTextFontHeight(12);

		SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
		SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
		SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

		SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
		SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

		SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
		SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
		SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));
		SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
		SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

		SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
			GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
		SetCloseEvent(TRUE);
	}


	

	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}

void CSelectTelnoDlg::SetTelNos( CString strExtensionTelno, CString strIncoTelno, CString strCellPhone )
{
	m_strExtensionTelno = strExtensionTelno;
	m_strIncoTelno = strIncoTelno;
	m_strCellPhone = strCellPhone;
}

void CSelectTelnoDlg::ReSizeCtrl()
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);	

	if (m_radioExtensionTelNo.GetSafeHwnd() && m_radioCellPhone.GetSafeHwnd() && m_radioInputTelNo.GetSafeHwnd() && m_editTelno.GetSafeHwnd())
	{
		CRect rtRadio(0, 0, 0, 0);
		rtRadio.left = 20;
		rtRadio.top = 25;
		rtRadio.right = rtRadio.left + 80;
		rtRadio.bottom = rtRadio.top + 20;
		m_radioExtensionTelNo.MoveWindow(rtRadio);

		rtRadio.OffsetRect(0, 30);
		m_radioCellPhone.MoveWindow(rtRadio);

		rtRadio.OffsetRect(0, 30);
		m_radioInputTelNo.MoveWindow(rtRadio);

		rtRadio.left = 110;
		rtRadio.right = rcClient.right - 20;
		m_editTelno.MoveWindow(rtRadio);
	}

	if(m_pOKCancelButtons && m_pOKCancelButtons->GetHWND())
	{
		CRect rcButtons(rcClient.left, rcClient.bottom+7 - BTN_HEIGHT, rcClient.right, rcClient.bottom + 7);
		m_pOKCancelButtons->SetClientRect(rcButtons);
	}
}

void CSelectTelnoDlg::OnBnClickedOk()
{
	if (m_radioExtensionTelNo.GetCheck() == BST_CHECKED)
	{
		m_strForwardingTelNo = m_strExtensionTelno;
	}
	else if (m_radioCellPhone.GetCheck() == BST_CHECKED)
	{
		m_strForwardingTelNo = m_strCellPhone;
	}
	else if (m_radioInputTelNo.GetCheck() == BST_CHECKED)
	{
		CString strEditTelNo;
		m_editTelno.GetWindowText(strEditTelNo);
		m_strForwardingTelNo = strEditTelNo;
	}

	OnOK();
}

CString CSelectTelnoDlg::GetForwardingTelNo()
{
	return m_strForwardingTelNo;
}

void CSelectTelnoDlg::OnBnClickedRadioTel1()
{
	m_editTelno.EnableWindow(FALSE);
}

void CSelectTelnoDlg::OnBnClickedRadioTel2()
{
	m_editTelno.EnableWindow(FALSE);
}

void CSelectTelnoDlg::OnBnClickedRadioTel3()
{
	m_editTelno.EnableWindow(TRUE);
}

int CSelectTelnoDlg::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_pOKCancelButtons = new COKCancelButtons(this, this);
	m_pOKCancelButtons->LoadSkin();

	m_pOKCancelButtons->SetButtonText(LoadStringFromResource(IDS_STRING612), 
		LoadStringFromResource(IDS_STRING569));

	return 0;
}

void CSelectTelnoDlg::OnDestroy()
{
	if(m_pOKCancelButtons)
	{
		::DestroyWindow(m_pOKCancelButtons->GetHWND());
		SAFE_DELETE(m_pOKCancelButtons);
	}

	__super::OnDestroy();
}

void CSelectTelnoDlg::OnButtonClicked( COKCancelButtons::BUTTONS button )
{
	ASSERT(button != COKCancelButtons::All);

	if(button == COKCancelButtons::OK)
	{
		OnBnClickedOk();
	}
	else if(button == COKCancelButtons::Cancle)
	{
		OnCancel();
	}
	else
	{
		ASSERT(FALSE);
	}
}
